local uci = require "luci.model.uci".cursor()
local ds = require "luci.dispatcher" 
local wa = require "luci.tools.webadmin"

local fs = require "nixio.fs"

local queryName
if arg[1] then
    queryName = arg[1]
end

m = Map("query_map", translate("Query Map"))

s = m:section(TypedSection, "query", "", "")
s.anonymous = true
s.addremove = true

local function parseFunctionFactory(errmsg)
    return function(self, section, novld, ...)
        local v = self:formvalue(section)
        if e == "1" and (type(v) ~= "string" or v == "") then
            self:add_error(section, "invalid", errmsg)
        end
        Value.parse(self, section, novld, ...)
    end
end

address = s:option(Value, "address", translate("Address"), translate(""))
address.datatype = "integer"
address.parse = parseFunctionFactory("Address cannot be empty")

query_name = s:option(Value, "query_name", translate("Query Name"), translate(""))
query_name.default = queryName

name = s:option(Value, "name", translate("Name"), translate(""))
name.datatype = "string"
name.parse = parseFunctionFactory("Name cannot be empty")

data_type = s:option(ListValue, "data_type", translate("Dataype"))
data_type:value("bit", translate("bit"))
data_type.default = "none"
data_type.rmempty = false

scaling_a = s:option(Value, "scaling_a", translate("Scaling A"), translate(""))
scaling_a.datatype = "range(0,10)"
scaling_a.parse = parseFunctionFactory("Scaling cannot be empty")

scaling_b = s:option(Value, "scaling_b", translate("Scaling B"), translate(""))
scaling_b.datatype = "range(0,10)"
scaling_b.parse = parseFunctionFactory("Scaling cannot be empty")

process_or_config = s:option(ListValue, "process_or_config", translate("Process Or Config"))
process_or_config:value("process", translate("Process"))
process_or_config:value("config", translate("Config"))
process_or_config.default = "none"
process_or_config.rmempty = false

hi_threashold = s:option(Value, "hi_threashold", translate("Hi Threashold"), translate(""))
hi_threashold.datatype = "range(0,10000)"
hi_threashold.parse = parseFunctionFactory("Hi Threashold cannot be empty")

low_threashold = s:option(Value, "low_threashold", translate("Low Threashold"), translate(""))
low_threashold.datatype = "range(0,10000)"
low_threashold.parse = parseFunctionFactory("Low Threashold cannot be empty")

send_alarm = s:option(ListValue, "send_alarm", translate("Send Alarm"))
send_alarm:value("high", translate("High"))
send_alarm.default = "none"
send_alarm.rmempty = false

return m
